package dev.fyloz.colorrecipesexplorer.dtos

import dev.fyloz.colorrecipesexplorer.Constants
import java.time.LocalDate
import javax.validation.constraints.Min
import javax.validation.constraints.NotBlank
import javax.validation.constraints.NotEmpty

data class TouchUpKitDto(
    override val id: Long = 0L,

    @field:NotBlank
    val project: String,

    @field:NotBlank
    val buggy: String,

    @field:NotBlank
    val company: String,

    @field:Min(1, message = Constants.ValidationMessages.SIZE_GREATER_OR_EQUALS_ONE)
    val quantity: Int,

    val shippingDate: LocalDate,

    val completionDate: LocalDate?,

    val completed: Boolean = false,

    val expired: Boolean = false,

    @field:NotEmpty
    val finish: List<String>,

    @field:NotEmpty
    val material: List<String>,

    @field:NotEmpty
    val content: List<TouchUpKitProductDto>
) : EntityDto

data class TouchUpKitProductDto(
    override val id: Long = 0L,

    val name: String,

    val description: String?,

    val quantity: Float,

    val ready: Boolean
) : EntityDto