package dev.fyloz.colorrecipesexplorer.model

import org.hibernate.annotations.ColumnDefault
import javax.persistence.*

@Entity
@Table(name = "material_type")
data class MaterialType(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long,

    @Column(unique = true)
    val name: String = "",

    @Column(unique = true)
    val prefix: String = "",

    @Column(name = "use_percentages")
    @ColumnDefault("false")
    val usePercentages: Boolean = false,

    @Column(name = "system_type")
    @ColumnDefault("false")
    val systemType: Boolean = false
) : ModelEntity