package dev.fyloz.colorrecipesexplorer.model.account

import dev.fyloz.colorrecipesexplorer.model.ModelEntity
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import java.time.LocalDateTime
import javax.persistence.*

@Entity
@Table(name = "user")
data class User(
    @Id
    override val id: Long,

    @Column(name = "first_name")
    val firstName: String,

    @Column(name = "last_name")
    val lastName: String,

    val password: String,

    @Column(name = "default_group_user")
    val isDefaultGroupUser: Boolean,

    @Column(name = "system_user")
    val isSystemUser: Boolean,

    @ManyToOne
    @JoinColumn(name = "group_id")
    @Fetch(FetchMode.SELECT)
    val group: Group?,

    @Enumerated(EnumType.STRING)
    @ElementCollection(fetch = FetchType.EAGER)
    @CollectionTable(name = "user_permission", joinColumns = [JoinColumn(name = "user_id")])
    @Column(name = "permission")
    @Fetch(FetchMode.SUBSELECT)
    val permissions: List<Permission>,

    @Column(name = "last_login_time")
    val lastLoginTime: LocalDateTime?
) : ModelEntity